#
# Wirex version of the egcs spec file
#
#	$Id: sg-egcs.spec,v 1.7 2001/08/14 20:39:01 root Exp root $
#

%define STDC_VERSION 2.9.0
%define EGCS_VERSION 1.1.2
%define MAJOR_VERSION 1.1
Summary: The GNU Compiler Collection.
Name: sg-egcs
Version: %{EGCS_VERSION}
Release: 30_SG201_cobalt
Copyright: GPL
Group: Development/Languages
Source0: egcs-%{EGCS_VERSION}-sg.tar.bz2
#Source1: egcs-libstdc++-compat.tar.gz
#Patch0: ftp://ftp.varesearch.com/pub/support/hjl/egcs/egcs-1.1.2-linux.patch
#Patch1: egcs-1.1.2-davem.patch
#Patch2: egcs-1.1.2-gcse.patch
#Patch3: egcs-1.1.2-cpu.patch
#Patch4: egcs-1.1.2-fixtrunc.patch
#Patch5: egcs-1.1.2-expr.patch
#Patch6: egcs-1.1.2-strlen.patch
#Patch7: egcs-1.1.2-warn.patch
#Patch8: egcs-1.1.2-addressof.patch
#Patch9: egcs-1.1.2-fold.patch
#Patch10: egcs-1.1.2-asm.patch
#Patch666: egcs-1.1.2-StackGuard-stout.patch
Buildroot: /var/tmp/sg-egcs-%{EGCS_VERSION}-root
Url: http://gcc.cygnus.com/
Requires: binutils >= 2.9.1.0.21
Obsoletes: gcc
Provides: gcc
Requires: sg-cpp = %{EGCS_VERSION}
Requires: glibc-devel
Prereq: /sbin/install-info

%description
The sg-egcs package contains the GNU Compiler Collection: cc, gcc and
egcs. You'll need this package in order to compile C/C++ code.

%package c++
Summary: C++ support for the gcc compiler.
Group: Development/Languages
Requires: sg-egcs = %{EGCS_VERSION}
Obsoletes: gcc-c++
Obsoletes: libstdc++-devel
Obsoletes: libg++-devel
Requires: sg-libstdc++ = %{STDC_VERSION}
Requires: sg-cpp = %{EGCS_VERSION}

%description c++
This package adds C++ support to the GNU C compiler. It includes
support for most of the current C++ specification, including templates
and exception handling. It does include the static standard C++
library and C++ header files; the library for dynamically linking
programs is available separately.

%package objc
Summary: Objective C support for the gcc compiler.
Group: Development/Languages
Requires: sg-egcs = %{EGCS_VERSION}
Obsoletes: gcc-objc
Requires: sg-cpp = %{EGCS_VERSION}

%description objc
Egcs-objc provides Objective C support for the GNU C compiler (gcc).
Mainly used on systems running NeXTSTEP, Objective C is an 
object-oriented derivative of the C language.

Install egcs-objc if you are going to do Objective C development and
you would like to use the gcc compiler.  You'll also need gcc, which
is included in the egcs package.

%package g77
Summary: Fortran 77 support for the gcc compiler.
Group: Development/Languages
Requires: sg-egcs = %{EGCS_VERSION}
Prereq: /sbin/install-info

%description g77
The egcs-g77 package provides support for compiling Fortran 77
programs with the GNU gcc compiler.

You should install egcs-g77 if you are going to do Fortran development
and you would like to use the gcc compiler.  You will also need gcc,
which is included in the egcs package.

%package -n sg-libstdc++
Summary: The EGCS Standard C++ library v3.
Group: System Environment/Libraries
Obsoletes: libg++
Version: %{STDC_VERSION}
Prereq: /sbin/ldconfig
Prereq: /sbin/install-info

%description -n sg-libstdc++
The libstdc++ package contains a snapshot of the EGCS Standard C++
Library v3, an ongoing project to implement the ISO 14882 Standard C++
library.

%package -n sg-cpp
Summary: The GNU C-Compatible Compiler Preprocessor.
Group: Development/Languages
Prereq: /sbin/install-info

%description -n sg-cpp
Cpp (or cccp) is the GNU C-Compatible Compiler Preprocessor.
Cpp is a macro processor which is used automatically
by the C compiler to transform your program before actual
compilation. It is called a macro processor because it allows
you to define macros, abbreviations for longer
constructs.

The C preprocessor provides four separate functionalities: the
inclusion of header files (files of declarations that can be
substituted into your program); macro expansion (you can define macros,
and the C preprocessor will replace the macros with their definitions
throughout the program); conditional compilation (using special
preprocessing directives, you can include or exclude parts of the
program according to various conditions); and line control (if you use
a program to combine or rearrange source files into an intermediate
file which is then compiled, you can use line control to inform the
compiler about where each source line originated).

You should install this package if you are a C programmer and you use
macros.

%prep
%setup -q -n egcs-%{MAJOR_VERSION}
#%patch0 -p1
#%patch1 -p1
#%patch2 -p1
#%patch3 -p1
#%patch4 -p1
#%patch5 -p1
#%patch6 -p1
#%patch7 -p1
#%patch8 -p1
#%patch9 -p1
#%patch10 -p0

#%patch666 -p4

#mkdir compat
#tar xzf %{SOURCE1} -C compat
cd gcc ; autoconf ; cd ..

%build
rm -rf obj-$RPM_ARCH-linux
mkdir obj-$RPM_ARCH-linux
cd obj-$RPM_ARCH-linux
# If only this worked.
#../configure  --prefix=/usr --program-suffix=-sg \
../configure  --prefix=/usr/sg \
	--enable-shared --enable-threads \
	$RPM_ARCH-redhat-linux

PATH=$PATH:/sbin:/usr/sbin
# gperf is most likely broken on alpha and sparc 
touch  ../gcc/c-gperf.h
make MAKEINFO="makeinfo --no-split"  bootstrap-lean
make MAKEINFO="makeinfo --no-split" info

%install
rm -rf $RPM_BUILD_ROOT
cd obj-$RPM_ARCH-linux
PATH=$PATH:/sbin:/usr/sbin
make install \
	prefix=$RPM_BUILD_ROOT/usr/sg \
	mandir=$RPM_BUILD_ROOT/usr/man/man1 \
	MAKEINFO="makeinfo --no-split" 
FULLVER=$($RPM_BUILD_ROOT/usr/sg/bin/gcc --version)
FULLPATH=$(dirname $RPM_BUILD_ROOT/usr/sg/lib/gcc-lib/$RPM_ARCH-*/$FULLVER/cc1)

file $RPM_BUILD_ROOT/usr/sg/bin/* | grep ELF | cut -d':' -f1 | xargs strip || :
strip $FULLPATH/{cc1,cc1obj,cc1plus,cpp,f771,collect2}

# fix some things
ln $RPM_BUILD_ROOT/usr/sg/bin/$RPM_ARCH-redhat-linux-gcc $RPM_BUILD_ROOT/usr/sg/bin/egcs
ln -sf gcc $RPM_BUILD_ROOT/usr/sg/bin/cc
ln $RPM_BUILD_ROOT/usr/sg/man/man1/gcc.1 $RPM_BUILD_ROOT/usr/sg/man/man1/egcs.1
#mv $RPM_BUILD_ROOT/usr/include/g++-2 $RPM_BUILD_ROOT/usr/include/g++

rm -f $RPM_BUILD_ROOT/usr/info/dir
install -m 644 $RPM_ARCH-redhat-linux/libio/iostream.info $RPM_BUILD_ROOT/usr/sg/info
gzip -n -9f $RPM_BUILD_ROOT/usr/sg/info/*.info* 

ln -sf g77.1 $RPM_BUILD_ROOT/usr/sg/man/man1/f77.1
ln -sf g77 $RPM_BUILD_ROOT/usr/sg/bin/f77

mkdir -p $RPM_BUILD_ROOT/lib
ln -sf ../${FULLPATH##$RPM_BUILD_ROOT/}/cpp $RPM_BUILD_ROOT/lib/cpp

ln -sf cccp.1 $RPM_BUILD_ROOT/usr/sg/man/man1/cpp.1

mkdir -p $RPM_BUILD_ROOT/usr/lib

#install the compatibility libstdc++ library
[ -d ../compat/$RPM_ARCH ] && install -m 755 ../compat/$RPM_ARCH/* $RPM_BUILD_ROOT/usr/lib/

# build a fake libstdc++.so.2.9 library for compatibility with other distros
pushd $RPM_BUILD_ROOT/usr/lib ; {
	touch foo.c
	../sg/bin/g++ -fPIC -L. -shared -o libstdc++.so.2.9.dummy \
		-B$FULLPATH/ -Wl,-soname,libstdc++.so.2.9
	rm -f foo.c
} ; popd

# extra!!!

ln -f $RPM_BUILD_ROOT/usr/sg/lib/libstdc++-2-libc*-%{STDC_VERSION}.so $RPM_BUILD_ROOT/usr/lib/

%clean
rm -rf $RPM_BUILD_ROOT

%post
#/sbin/install-info --info-dir=/usr/info /usr/info/gcc.info.gz

%preun
#if [ $1 = 0 ]; then
#   /sbin/install-info --delete --info-dir=/usr/info /usr/info/gcc.info.gz
#fi

%post -n sg-cpp
#/sbin/install-info --info-dir=/usr/info /usr/info/cpp.info.gz

%preun -n sg-cpp
#if [ $1 = 0 ]; then
#   /sbin/install-info --delete --info-dir=/usr/info /usr/info/cpp.info.gz
#fi

%post g77
#/sbin/install-info --info-dir=/usr/info /usr/info/g77.info.gz

%preun g77
#if [ $1 = 0 ]; then
#   /sbin/install-info --delete --info-dir=/usr/info /usr/info/g77.info.gz
#fi

%preun -n sg-libstdc++
#if [ $1 = 0 ]; then
#   /sbin/install-info --delete --info-dir=/usr/info /usr/info/iostream.info.gz
#fi

%post -n sg-libstdc++
/sbin/ldconfig
#/sbin/install-info --info-dir=/usr/info /usr/info/iostream.info.gz

%postun -n sg-libstdc++ -p /sbin/ldconfig

%files
%doc README* COPYING COPYING.LIB
%dir /usr/sg/lib/gcc-lib
%dir /usr/sg/lib/gcc-lib/%{_target_cpu}-redhat-linux
%dir /usr/sg/lib/gcc-lib/%{_target_cpu}-redhat-linux/egcs-*
%dir /usr/sg/lib/gcc-lib/%{_target_cpu}-redhat-linux/egcs-*/include
/usr/sg/bin/%{_target_cpu}-redhat-linux-gcc
/usr/sg/bin/egcs*
/usr/sg/bin/gcov*
/usr/sg/bin/protoize*
/usr/sg/bin/unprotoize*
/usr/sg/bin/gcc*
/usr/sg/bin/cc*
#/usr/info/gcc*

#/usr/man/man1/gcc.1*
#/usr/man/man1/egcs.1*

/usr/sg/lib/gcc-lib/%{_target_cpu}-redhat-linux/egcs-*/SYSCALLS.c.X
/usr/sg/lib/gcc-lib/%{_target_cpu}-redhat-linux/egcs-*/cc1
/usr/sg/lib/gcc-lib/%{_target_cpu}-redhat-linux/egcs-*/collect2
/usr/sg/lib/gcc-lib/%{_target_cpu}-redhat-linux/egcs-*/libgcc.a
/usr/sg/lib/gcc-lib/%{_target_cpu}-redhat-linux/egcs-*/libgcc.map
/usr/sg/lib/gcc-lib/%{_target_cpu}-redhat-linux/egcs-*/specs

%ifnarch alpha
/usr/sg/lib/gcc-lib/%{_target_cpu}-redhat-linux/egcs-*/*.o
%endif

/usr/sg/%{_target_cpu}-redhat-linux

/usr/sg/lib/gcc-lib/%{_target_cpu}-redhat-linux/egcs-*/include/README
/usr/sg/lib/gcc-lib/%{_target_cpu}-redhat-linux/egcs-*/include/float.h
/usr/sg/lib/gcc-lib/%{_target_cpu}-redhat-linux/egcs-*/include/iso646.h
/usr/sg/lib/gcc-lib/%{_target_cpu}-redhat-linux/egcs-*/include/limits.h
/usr/sg/lib/gcc-lib/%{_target_cpu}-redhat-linux/egcs-*/include/proto.h
/usr/sg/lib/gcc-lib/%{_target_cpu}-redhat-linux/egcs-*/include/stdarg.h
/usr/sg/lib/gcc-lib/%{_target_cpu}-redhat-linux/egcs-*/include/stdbool.h
/usr/sg/lib/gcc-lib/%{_target_cpu}-redhat-linux/egcs-*/include/stddef.h
/usr/sg/lib/gcc-lib/%{_target_cpu}-redhat-linux/egcs-*/include/syslimits.h
/usr/sg/lib/gcc-lib/%{_target_cpu}-redhat-linux/egcs-*/include/va-*.h
/usr/sg/lib/gcc-lib/%{_target_cpu}-redhat-linux/egcs-*/include/varargs.h
%ifarch ppc
/usr/sg/lib/gcc-lib/%{_target_cpu}-redhat-linux/egcs-*/include/*-asm.h
%endif

%files -n sg-cpp
#/lib/cpp
#/usr/man/man1/cpp.1*
#/usr/man/man1/cccp.1*
#/usr/info/cpp.info*.gz
/usr/sg/lib/gcc-lib/%{_target_cpu}-redhat-linux/egcs-*/cpp

%files c++
#/usr/man/man1/g++.1*
/usr/sg/bin/g++
/usr/sg/bin/c++
/usr/sg/bin/c++filt
/usr/sg/lib/gcc-lib/%{_target_cpu}-redhat-linux/egcs-*/cc1plus
/usr/sg/lib/gcc-lib/%{_target_cpu}-redhat-linux/egcs-*/libstdc*
/usr/sg/lib/gcc-lib/%{_target_cpu}-redhat-linux/egcs-*/include/exception
/usr/sg/lib/gcc-lib/%{_target_cpu}-redhat-linux/egcs-*/include/new
/usr/sg/lib/gcc-lib/%{_target_cpu}-redhat-linux/egcs-*/include/typeinfo
/usr/sg/lib/gcc-lib/%{_target_cpu}-redhat-linux/egcs-*/include/new.h
/usr/sg/include/g+*
/usr/sg/lib/libstdc++-2-libc*-%{STDC_VERSION}.a
/usr/sg/lib/libstdc++-2-libc*-%{STDC_VERSION}.so
/usr/sg/lib/libstdc++-libc*.a.2
%ifarch ppc
/usr/sg/lib/nof
%endif

%files objc
/usr/sg/lib/gcc-lib/%{_target_cpu}-redhat-linux/egcs-*/cc1obj
/usr/sg/lib/gcc-lib/%{_target_cpu}-redhat-linux/egcs-*/libobjc.a
/usr/sg/lib/gcc-lib/%{_target_cpu}-redhat-linux/egcs-*/include/objc

%files g77
/usr/sg/bin/g77
/usr/sg/bin/f77
/usr/sg/info/g77*
/usr/sg/lib/gcc-lib/%{_target_cpu}-redhat-linux/egcs-*/f771
/usr/sg/lib/gcc-lib/%{_target_cpu}-redhat-linux/egcs-*/libg2c.a
#/usr/man/man1/g77.1*
#/usr/man/man1/f77.1*
/usr/sg/lib/gcc-lib/*-redhat-linux/egcs-*/include/g2c.h

%files -n sg-libstdc++
/usr/lib/libstdc++-2-libc*-%{STDC_VERSION}.so
%ifarch i386 sparc alpha
/usr/lib/libstdc++.so.2.8.0
%endif
%ifarch i386 alpha
/usr/lib/libstdc++.so.2.7.2.8
/usr/lib/libg++.so.2.7.2.8
%endif
/usr/lib/libstdc++.so.2.9.dummy
#/usr/info/iostream.info*

%changelog
* Fri May 19 2000 Steve Beattie <steve@wirex.net>
- Added the canary_death_handler back as weak symbol to gcc/libgcc2.c. 
  Emacs and postgres were purposefully (brokenly?) side-stepping
  crtbegin.o -- I think they use their own constructors and destructors.
  I believe the correct fix should've been to make the death_handler
  included in glibc be a global symbol, but doing that seemed to break
  glibc in a non-obvious and apparantly unrelated way. <sigh>

* Thu Mar 16 2000 Steve Beattie <steve@wirex.net>
- Moved the canary_death_handler from gcc/libgcc2.c to gcc/crtstuff.c.
  This means that it will be created in crtbegin.o. This should fix the
  link order problem where binaries were depending on the existence of
  the canary_death_handler in libraries, and not being copied into the
  binary itself.

* Thu Feb 17 2000 Florian La Roche <Florian.LaRoche@redhat.com>
- fix type in libstdc++ %post

* Mon Feb 14 2000 Florian La Roche <Florian.LaRoche@redhat.com>
- add patch from Ulrich Drepper <drepper@redhat.com>:
  parse.y (simple_stmt): Allow :: token in asm parameter list

* Tue Feb 08 2000 Cristian Gafton <gafton@redhat.com>
- add the iostream info page to libstdc++

* Thu Feb 03 2000 Cristian Gafton <gafton@redhat.com>
- man pages are compressed

* Mon Jan 10 2000 Jim Kingdon <http://bugzilla.redhat.com/bugzilla>
- Add egcs-1.1.2-fold.patch from rth.  Update URL to http://gcc.gnu.org/.

* Fri Dec 3 1999 Jim Kingdon <http://developer.redhat.com>
- Replace egcs-1.1.2-fixtrunc.patch with egcs-1.1.2-integrate.patch
  (bugzilla #3777).  Add egcs-1.1.2-addressof.patch.  Depend on
  glibc-devel.

* Wed Sep 8 1999 Jim Kingdon <http://developer.redhat.com>
- Fix egcs-1.1.2-cpu.patch so that it works if more than one option
  from a set is specified.

* Thu Sep 3 1999 David S. Miller <davem@redhat.com>
- Fixup egcs-1.1.2-expr.patch to modify c-parse.in

* Wed Sep 1 1999 Jim Kingdon <http://developer.redhat.com>
- Add egcs-1.1.2-strlen.patch (fixes compiler core dump on certain strlen
  invocations) and egcs-1.1.2-warn.patch (makes -Wpointer-arith work
  with glibc-2.1.2-7).

* Thu Aug 19 1999 Jim Kingdon <http://developer.redhat.com>
- Replace egcs-1.1.2-global.patch (which is bogus according to Richard
  Henderson) with egcs-1.1.2-fixtrunc.patch (which fixes the same bug,
  and looks more likely to be right).

* Thu Aug 12 1999 Cristian Gafton <gafton@redhat.com>
- build a dummy libstsdc++.so.2.9 library to maintain compatibility with
  other distribution not using HJ's Linux patches.

* Tue Jul 30 1999 Jim Kingdon <http://developer.redhat.com>
- Add egcs-1.1.2-expr.patch to fix 3971 in bugzilla.

* Tue Jul 20 1999 Jim Kingdon <http://developer.redhat.com>
- Add egcs-1.1.2-global.patch, fixes core dumps.

* Mon Jul 12 1999 Cristian Gafton <gafton@redhat.com>
- improved CPU handling patch

* Thu Jun 24 1999 Cristian Gafton <gafton@redhat.com>
- added patch from rth to stop cpp from defining __i486__ macros on -m486
  (it is not supposed to according to the info page, and this makes code
  compiled with -m486 not run on i386 anymore)

* Mon May 17 1999 Matt Wilson <msw@redhat.com>
- added patch from Dave Miller

* Sun Mar 21 1999 Cristian Gafton <gafton@redhat.com> 
- auto rebuild in the new build environment (release 12)

* Wed Mar 17 1999 Cristian Gafton <gafton@redhat.com>
- version 1.1.2
- added patch from davem

* Fri Mar 12 1999 Cristian Gafton <gafton@redhat.com>
- version 1.1.2pre3

